{ Use for ExtEEPROM;
 
Device = 18F452
Clock = 20

// import libraries...
Include "ExtEEPROM.bas"
Include "usart.bas" 
Include "Convert.bas"
 
Dim 
    Variable As Byte,       // Variable used for data 
    Device_Address As Byte, // Register for I2C Address reference
    Memory_Address As Byte, // Register for EEPROM memory address
    Family As Byte          // Register for External EEPROM family setting
    
    USART.SetBaudrate(br19200) 
    
    Variable = 123          // Place the value "1" in the variable register
    Device_Address = %000   // Set the EEPROM I2C address
    Memory_Address = 10     // Set the EEPROM address location to 0
    Family = %1010          // Set the Family configeration as the binary number 1010
 
    // Write the value 123 to EEPROM 000 at memory location 10
    ExtEEPROM.Write(Variable, Memory_Address, Device_Address, Family)    
    // *** Note that Family is not required if = %1010 as this is the default value, eg,
    // ExtEEPROM.Write(Variable, Memory_Address, Device_Address)    
      
    // Read from EEPROM 000, memory location 10
    Variable = ExtEEPROM.Read(Memory_Address, Device_Address, Family)    
    USART.Write(Convert.DecToStr(Variable))
    
    While True
    Wend
}    
 
Module ExtEEPROM
 
Include "I2C.bas"
 
Dim EEPROM_Control As Byte
 
Public Sub Write(Data As Byte, Memory_Address As Word, Device_Address As Byte, EEPROM_Family As Byte = %1010)
    EEPROM_Control = (EEPROM_Family << 4) Or (Device_Address << 1)
    I2C.Start                                          // Write data to 
    I2C.WriteByte(EEPROM_Control)                      //  the external EEPROM
    I2C.WriteByte(Memory_Address.Byte1)                //        
    I2C.WriteByte(Memory_Address.Byte0)                //
    I2C.WriteByte(Data)                                //
    I2C.Stop                                           //
    DelayMS(10)                                        // Small delay required 
End Sub                                                //  between writes
 
Public Function Read(Memory_Address As Word, Device_Address As Byte, EEPROM_Family As Byte = %1010) As Byte
    EEPROM_Control = (EEPROM_Family << 4) Or (Device_Address << 1)
    I2C.Start                                          // Read data from 
    I2C.WriteByte(EEPROM_Control)                      //  the external EEPROM
    I2C.WriteByte(Memory_Address.Byte1)                //        
    I2C.WriteByte(Memory_Address.Byte0)                //
    I2C.Restart                                        // 
    I2C.WriteByte(EEPROM_Control + 1)                  //     
    Result = I2C.ReadByte(I2C_NOT_ACKNOWLEDGE)         // Store the functions                     
    I2C.Stop                                           //  result
End Function
 
I2C.Initialize
 
End

