Module Keypad16
// For use with PORTB and internal pullup resistors
// Note: Can be used with other ports, with pullup resistors on Row pins

{
Column1 = PORTB.0
Column2 = PORTB.1
Column3 = PORTB.2
Column4 = PORTB.3
Row1 = PORTB.4
Row2 = PORTB.5
Row3 = PORTB.6
Row4 = PORTB.7
}

// validate data port...
#option KEYPAD_PORT = PORTB
#if IsOption(KEYPAD_PORT) 
   #if Not IsValidPort(KEYPAD_PORT)
      #error KEYPAD_PORT, "Invalid option. Keypad must be connected to a valid port name."
   #endif
   #option _KEYPAD_PORT_TRIS = GetTRIS(KEYPAD_PORT)   
#endif 

// bring PORT and TRIS options into the module
Dim 
   FKeyPort As KEYPAD_PORT, 
   FKeyPortTris As _KEYPAD_PORT_TRIS


Public Function Value() As Byte
    Dim Counter As Byte
    Dim RowData As Byte
    Dim ColData As Byte
    
    Result = 0                           
    
    For Counter = 0 To 3                //
        FKeyPortTris = $FF              // Make all pins inputs
        FKeyPortTris.Bits(Counter) = 0  // Make a single Column an output
        FKeyPort.Bits(Counter) = 0      //  and set it low
        
        If (FKeyPort >> 4) <> %00001111 Then    // Check if any Rows are "Low"
            Coldata = Counter
            If FKeyPort.4 = 0 Then
                RowData = 1
            ElseIf FKeyPort.5 = 0 Then
                RowData = 5
            ElseIf FKeyPort.6 = 0 Then
                RowData = 9
            ElseIf FKeyPort.7 = 0 Then
                RowData = 13                
            EndIf            
            Result = Coldata + RowData
            Break          
        EndIf  
    Next
End Function

Public Sub Debounce()

    While Keypad16.Value <> 0           // Check if key is pressed
        DelayMS(10)                     // Wait for 10mS
    Wend  

End Sub

#if KEYPAD_PORT in (PORTB)
   INTCON2.7 = 0
#endif 

FKeyPortTris = $FF              // Make all pins inputs

End
